/*******************************************************************************
 * FoxRemoveHistoryUI generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxRemoveHistoryUI extends FoxUIBaseTransactionTask within FoxUI;

var transient array<string> OfferToRemoveMissionNames;
var transient bool bShowWorkingDialog;
var transient bool bKillWorkingDialog;
var private transient bool bHasWorkingDialog;
var private transient bool bOverallSuccess;
var private const localized string RemovingLabel;
var private const localized string RemovingLabelCaps;
var private const localized string RemovingFailureLabel;
var private const localized string RemovingFailureLabelInvalidItem;
var delegate<PostRemovingHistory> __PostRemovingHistory__Delegate;

delegate PostRemovingHistory(bool bSuccess)
{
    //return;    
}

function bool StartTask()
{
    local bool bSucceeding;
    local int I;

    // End:0x164
    if(super(FoxUIBaseTask).StartTask())
    {
        bSucceeding = true;
        bOverallSuccess = true;
        // End:0x56
        if(!ValidateRemoveHistory())
        {
            RemoveHistoryFailed(RemovingFailureLabelInvalidItem);
            bSucceeding = false;
        }
        // End:0x164
        else
        {
            Outer.ui_toggleCaptureInput(false);
            I = 0;
            J0x82:
            // End:0x149 [Loop If]
            if(I < OfferToRemoveMissionNames.Length)
            {
                // End:0x13B
                if(!Outer.PCOwner.OnlineSub.StoreInterface.RemoveHistory(OfferToRemoveMissionNames[I]))
                {
                    bSucceeding = false;
                    RemoveHistoryComplete(false, OfferToRemoveMissionNames[I]);
                }
                ++ I;
                // [Loop Continue]
                goto J0x82;
            }
            // End:0x164
            if(!bSucceeding)
            {
                ShowWorkingDialog();
                return true;
            }
        }
    }
    return bSucceeding;
    //return ReturnValue;    
}

protected function bool ValidateRemoveHistory()
{
    return OfferToRemoveMissionNames.Length > 0;
    //return ReturnValue;    
}

protected function RegisterOnlineDelegates()
{
    Outer.PCOwner.OnlineSub.StoreInterface.AddRemoveHistoryCompleteDelegate(0, RemoveHistoryComplete);
    //return;    
}

protected function CleanupOnlineDelegates()
{
    Outer.PCOwner.OnlineSub.StoreInterface.ClearRemoveHistoryCompleteDelegate(0, RemoveHistoryComplete);
    //return;    
}

protected function NotifyProcessComplete(FoxDialogBoxBase.EDialogBoxConfirmType Selection)
{
    local FoxItemCacheInventory InventoryCache;

    // End:0x16
    if(Selection == 1)
    {
        return;
    }
    OnWorkingDialogHide();
    bHasWorkingDialog = false;
    // End:0x80
    if(class'FoxDataStore_StoreData'.static.GetCachedInventory(InventoryCache))
    {
        InventoryCache.MergeUpdatedItems();
    }
    super(FoxUIBaseTask).NotifyProcessComplete(Selection);
    PostRemovingHistory(Selection == 0);
    //return;    
}

protected function ShowWorkingDialog()
{
    local DialogBoxProperties Properties;

    // End:0x14A
    if(bShowWorkingDialog && !bHasWorkingDialog)
    {
        bHasWorkingDialog = true;
        // End:0x64
        if(__OnWorkingDialogShow__Delegate != none)
        {
            OnWorkingDialogShow(RemovingLabelCaps);
            bShowWorkingDialog = false;
        }
        // End:0x14A
        else
        {
            Properties.DialogType = 0;
            Properties.TitleText = Outer.LocWorkingLabel;
            Properties.BodyText = RemovingLabel;
            Properties.bShowTimer = true;
            Properties.bCloseOnButtonPress = false;
            Outer.ShowDialogBox(Properties);
        }
    }
    //return;    
}

protected function HideWorkingDialog()
{
    // End:0x4B
    if(bKillWorkingDialog)
    {
        Outer.CloseDialogBox();
        OnWorkingDialogHide();
        bHasWorkingDialog = false;
    }
    //return;    
}

protected function RemoveHistoryComplete(bool bSuccess, const string sMissionName)
{
    Outer.ui_toggleCaptureInput(true);
    // End:0x5A
    if(OfferToRemoveMissionNames.Find(sMissionName) != -1)
    {
        OfferToRemoveMissionNames.RemoveItem(sMissionName);
        J0x5A:
    }
    // End:0x5A
    else
    {
    }
    // End:0x88
    if(!bSuccess)
    {
        bOverallSuccess = false;
        RemoveHistoryFailed(sMissionName);
    }
    // End:0xB5
    if(OfferToRemoveMissionNames.Length <= 0)
    {
        NotifyProcessComplete(((bOverallSuccess) ? 0 : 1));
    }
    //return;    
}

private final function RemoveHistoryFailed(string ErrorText)
{
    local DialogBoxProperties Properties;

    Outer.CloseDialogBox();
    Properties.DialogType = 1;
    Properties.TitleText = Outer.LocFailureLabel;
    Properties.BodyText = RemovingFailureLabel;
    Properties.OnDialogButtonPressed = NotifyProcessFailed;
    bHasWorkingDialog = false;
    Outer.ShowDialogBox(Properties);
    //return;    
}

defaultproperties
{
    RemovingLabelCaps="TRASHING EXPIRED MISSIONS..."
    RemovingFailureLabel="Unable to remove items for unknown reason."
    RemovingFailureLabelInvalidItem="Unable to remove invalid items."
}